%define apxs            %{_sbindir}/apxs
%define aprconf         %{_bindir}/apr-1-config
%define aplibdir        %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define apconfdir       %(%{apxs} -q SYSCONFDIR 2>/dev/null)
%define aprincludes     %(%{aprconf} --includes 2>/dev/null)
%define aplogdir        logs
%define section         free
%define build_free      1

Name:           mod_jk
Version:        1.2.30
Release:        %mkrel 1
Epoch:          0
Summary:        Tomcat mod_jk connector for Apache
#Vendor:        JPackage Project
#Distribution:  JPackage
License:        Apache License
Group:          Development/Java
URL:            http://tomcat.apache.org/
Source0:        http://www.apache.org/dist/tomcat/tomcat-connectors/jk/source/tomcat-connectors-%{version}-src.tar.gz
Source1:        http://www.apache.org/dist/tomcat/tomcat-connectors/jk/source/tomcat-connectors-%{version}-src.tar.gz.asc
Source2:        http://www.apache.org/dist/tomcat/tomcat-connectors/jk/source/tomcat-connectors-%{version}-src.tar.gz.md5
Patch0:         mod_jk-no-jvm1.patch
Patch1:		mod_jk-aplogerror.patch
Patch2:		tomcat-connectors-1.2.30-mod_jk.conf-use-separate-cache-dir.patch
Patch3:		tomcat-connectors-1.2.30-workers.properties-only-use-default-system-tomcat-node.patch
BuildRequires:  ant
BuildRequires:  ant-trax
BuildRequires:  apache-devel
BuildRequires:  java-devel
BuildRequires:  java-rpmbuild >= 0:1.5.38
BuildRequires:  libtool
BuildRequires:  perl
BuildRequires:  xalan-j2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Tomcat mod_jk connector for Apache.

%if %with apache1
%package        ap13
Summary:        Tomcat mod_jk connector for Apache 1.3.x
Group:          Development/Java
Obsoletes:      mod_jk < %{epoch}:%{version}-%{release}
Provides:       mod_jk = %{epoch}:%{version}-%{release}
Obsoletes:      tomcat-mod < %{epoch}:%{version}-%{release}

%description    ap13
Tomcat mod_jk connector for Apache 1.3.x.
%endif

%package        ap20
Summary:        Tomcat mod_jk connector for Apache 2.0.x
Group:          Development/Java
Obsoletes:      mod_jk < %{epoch}:%{version}-%{release}
Provides:       mod_jk = %{epoch}:%{version}-%{release}
Obsoletes:      tomcat-mod < %{epoch}:%{version}-%{release}

%description    ap20
Tomcat mod_jk connector for Apache 2.0.x.

%package        manual
Summary:        Tomcat mod_jk connector manual
Group:          Development/Java

%description    manual
Tomcat mod_jk connector manual.

%package        tools
Group:          Development/Java
Summary:        Analysis and report tools for mod_jk

%description    tools
Miscellaneous mod_jk analysis and report tools.

%prep
%setup -q -n tomcat-connectors-%{version}-src
%if %{build_free}
%patch0 -p1
%endif
%patch1 -p0
%patch2 -p1 -b .cache_dir~
%patch3 -p1 -b .multi_nodes
(cd native && %{__libtoolize} --copy --force)

%{__perl} -pi -e 's|/usr/local/bin\b|%{_bindir}|' tools/reports/*.pl
%{__perl} -pi -e 's|^(APXSCPPFLAGS=.*)$|$1 %{aprincludes}|' \
  native/common/Makefile.in

%build
cd native

%{configure2_5x} \
  --with-apxs=%{apxs} \
  --with-java-home=%{java_home} \
  --with-java-platform=2 \
  --enable-jni \
%if %with apache1
  --enable-EAPI
%endif

# See <http://marc.theaimsgroup.com/?l=tomcat-dev&m=105600821630990>
%if %without apache1
export LIBTOOL=`%{apxs} -q LIBTOOL 2>/dev/null`
# Handle old apxs (without -q LIBTOOL), eg Red Hat 8.0 and 9.
if test -z "$LIBTOOL"; then
  LIBTOOL=%{__libtool}
fi
%{make} \
  LIBTOOL="$LIBTOOL" \
  EXTRA_CFLAGS="%{optflags}" \
  EXTRA_CPPFLAGS="%{aprincludes}"
%else
%{make} EXTRA_CFLAGS="$RPM_OPT_FLAGS"
%endif
cd ..

cd xdocs ; CLASSPATH=$(%{_bindir}/build-classpath xalan-j2-serializer) %{ant} ; cd ..

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{aplibdir}
%{__install} -pm 0755 \
  native/jni/jk_jnicb.so %{buildroot}%{aplibdir}/jk_jnicb.so
%if %without apache1
%{__install} -pm 0755 \
  native/apache-2.0/mod_jk.so %{buildroot}%{aplibdir}/mod_jk.so
%else
%{__install} -pm 0755 \
  native/apache-1.3/mod_jk.so.0.0.0 %{buildroot}%{aplibdir}/mod_jk.so
%endif
%{__mkdir_p} %{buildroot}%{_bindir}
%{__install} -pm 0755 tools/reports/*.pl %{buildroot}%{_bindir}

%{__install} -m644 conf/workers.properties -D %{buildroot}%{_sysconfdir}/httpd/conf/workers.properties
%{__install} -m644 conf/httpd-jk.conf -D %{buildroot}%{_sysconfdir}/httpd/modules.d/30_mod_jk.conf
%{__mkdir_p} %{buildroot}/var/cache/httpd/mod_jk
touch %{buildroot}/var/cache/httpd/mod_jk/mod_jk.shm

%post ap20
service httpd condrestart

%postun ap20
service httpd condrestart

%clean
%{__rm} -rf %{buildroot}

%if %with apache1
%files ap13
%defattr(0644,root,root,0755)
%doc LICENSE NOTICE mod_jk.conf.sample workers.properties.sample
%doc native/BUILDING.txt native/CHANGES native/NEWS native/README.txt native/STATUS.txt native/TODO.txt
%defattr(-,root,root,-)
%{aplibdir}/*
%else
%files ap20
%defattr(0644,root,root,0755)
%doc LICENSE NOTICE conf/workers.properties.multi_nodes conf/workers.properties.minimal
%doc native/BUILDING.txt native/CHANGES native/NEWS native/README.txt native/STATUS.txt native/TODO.txt
%defattr(-,root,root,-)
%{aplibdir}/*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_jk.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/workers.properties
%attr(0700,apache,root) %dir /var/cache/httpd/mod_jk
%attr(0600,apache,root) %ghost /var/cache/httpd/mod_jk/mod_jk.shm
%endif

%files manual
%defattr(0644,root,root,0755)
%doc build/docs/*

%files tools
%defattr(0644,root,root,0755)
%doc tools/reports/README.txt
%attr(0755,root,root) %{_bindir}/*




%changelog
* Mon Jun 28 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 0:1.2.30-1mdv2011.0
+ Revision: 549305
- switch back to default and more advanced configuration, but now with one of the
  two nodes disabled, standard ajp13 port (8009) used by default system tomcat
  used for both, everything should hopefully work fully out of the box with no
  errors now... :)
- fix typo in path, should be mod_jk, not mot_jdk
- be sure to patch config to actually use /var/cache/httpd/mod_jk
  * use minimal configuration as default as it actually works out of the box with
  current configuration wrt. tomcat etc. on the distribution otherwise
- * ditch outdated sample configurations shipped as docs
  * ship with default configuration to use..

* Fri Apr 30 2010 Luis Daniel Lucio Quiroz <dlucio@mandriva.org> 0:1.2.30-1mdv2010.1
+ Revision: 541110
- New 1.3.30

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

* Fri Jan 11 2008 David Walluck <walluck@mandriva.org> 0:1.2.26-0.0.1mdv2008.1
+ Revision: 147886
- 1.2.26

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Dec 16 2007 Anssi Hannula <anssi@mandriva.org> 0:1.2.25-2mdv2008.1
+ Revision: 120989
- buildrequire java-rpmbuild, i.e. build with icedtea on x86(_64)

* Tue Aug 14 2007 David Walluck <walluck@mandriva.org> 0:1.2.25-1mdv2008.0
+ Revision: 63426
- 1.2.25

* Mon May 21 2007 David Walluck <walluck@mandriva.org> 0:1.2.23-1mdv2008.0
+ Revision: 29523
- 1.2.23
- version OP

* Wed Apr 25 2007 David Walluck <walluck@mandriva.org> 0:1.2.22-1mdv2008.0
+ Revision: 18104
- 1.2.22


* Tue Dec 19 2006 David Walluck <walluck@mandriva.org> 1.2.19-3mdv2007.0
+ Revision: 99186
- conditionalize apache1 package
- Obsoletes: mod_jk

* Sun Dec 17 2006 David Walluck <walluck@mandriva.org> 0:1.2.19-1mdv2007.1
+ Revision: 98240
- 1.2.19

* Sat Nov 04 2006 David Walluck <walluck@mandriva.org> 0:1.2.6-3.4.2mdv2007.1
+ Revision: 76387
- rebuild
- Import mod_jk

* Sat Oct 29 2005 David Walluck <walluck@mandriva.org> 0:1.2.6-3.4.1mdk
- change apxs to apache-devel to stop the emails that I am getting

* Mon Sep 12 2005 David Walluck <walluck@mandriva.org> 0:1.2.6-3.1mdk
- release

* Thu May 05 2005 Joe Orton <jorton@redhat.com> 0:1.2.6-3jpp_4fc
- add dependency on httpd-mmn
- package NOTICE in docdir per ASL2.0 requirements

* Wed May 04 2005 Bill Nottingham <notting@redhat.com> - 0:1.2.6-3jpp_3fc
- temporarily disable -tools subpackage (#156757)

* Fri Apr 29 2005 Gary Benson <gbenson@redhat.com> - 0:1.2.6-3jpp_2fc
- Actually build more than just an empty debuginfo package (#151415).

* Tue Apr 05 2005 Gary Benson <gbenson@redhat.com> - 0:1.2.6-3jpp_1fc
- Build into Fedora.

* Wed Dec 08 2004 Fernando nasser <fnasser@redhat.com> - 0:1.2.6-3jpp_1rh
- First Red Hat release
- Build by default for Apache 2.0.x
- Add --tag to remaining LIBTOOL invocations

* Tue Oct 05 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-3jpp
- do not apply RHES 2.1 libtool workaround to apache2 builds

* Tue Oct 05 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-2jpp
- Add RHES 2.1 libtool workaround

* Thu Sep 30 2004 Nicolas Mailhot <nim@jpackage.org> - 0:1.2.6-1jpp
- Update to 1.2.6 as per Henri's suggestion:
  "JK2 is not production ready"
- Change default target from Tomcat 4 to Tomcat 5. Tomcat 5.5 is out and 
  Tomcat 5 is now the official stable version
- initial built on RHES 3, RHES 2.1 and RH 7.3

